#!/usr/bin/perl -w -I/usr/sausalito/perl -I.
#$Id: enableAM.pl,v 1.1.6.1 2002/01/08 22:44:54 will Exp $
# Copyright (c) Cobalt Networks 2000
# 
#
use strict;
use CCE;

my $autogrep = '/usr/sausalito/handlers/base/dns/secondary_dns_autogrep.pl';
my $autolink = '/etc/cron.quarter-hourly/secondary_dns_autogrep.pl';

my $cce = new CCE;
$cce->connectfd();

# retreive object data:
my $oid = $cce->event_oid();
my $ns = $cce->event_namespace();
my $prop = $cce->event_property();
my ($ok, $newobj, $oldobj) = $cce->get($oid, $ns);

if (!$oid || !$ns ||!$prop) {
  $cce->bye('FAIL', 'Bad oid or namespace');
  exit(1);
}

my ($oldval, $newval);
$oldval = $oldobj->{$prop} ? 1 : 0;
$newval = $newobj->{$prop} ? 1 : 0;

# only set on a real change of boolean value, not just string value
if (!($oldval eq $newval)) {
	my @oids = $cce->find("ActiveMonitor");
	$cce->set($oids[0], "DNS", {enabled => $newval});

	if($newval && (-e $autogrep)) {
		symlink($autogrep, $autolink);
	} elsif (-e $autogrep) {
		unlink($autolink);
	}
}

$cce->bye('SUCCESS');
exit(0);
