#!/usr/bin/perl
# Test for bind 8.2.x secondary db corruption
#
# The syntax appears to be "named-xfer[<pid>]: send AXFR query 0 to <IP>"
# erroneously prepended to the db by named.
#
# This utility scans db files and tests/repairs this issue.
#

use strict;

my $named_conf = '/etc/named.conf';
my $named_dir = '/etc/named/';

my @sec_db_files;
my $mark = 0;
open(CONF, $named_conf) || exit 0;
while(<CONF>)
{
	if(/type\s+slave/)
	{
		$mark = 1;
	}
	elsif($mark && /file\s+\"([^\"]+)\"/)
	{
		push(@sec_db_files, $1) if (-r $named_dir.$1);
		$mark = 0;
	}
}

foreach my $db_file (@sec_db_files)
{
	open(ZONE, $named_dir.$db_file) || next;
	my $test = <ZONE>;
	if($test =~ /^named\-xfer/)
	{
		my $fixed;
		while(<ZONE>) { $fixed .= $_; }
		close(ZONE);

		open(UPDATED, ">$named_dir$db_file") || next;
		print UPDATED $fixed;
		close(UPDATED);

		chmod(0640, $named_dir.$db_file);
		system('/etc/rc.d/init.d/named reload >/dev/null 2>&1');
	}
	else
	{
		close(ZONE);
	}
}

exit 0;


